unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ButtonRegenerer: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Panel1: TPanel;
    ButtonWM_CLOSE: TButton;
    Label2: TLabel;
    Panel2: TPanel;
    ButtonTerminate: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure ButtonRegenererClick(Sender: TObject);
    procedure ButtonWM_CLOSEClick(Sender: TObject);
    procedure ButtonTerminateClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

// cette fonction sera appel pour chaque lorsque l'on appelera l'API EnumWindows
function EnumWindowsCallback(hWnd: HWND; lParam: LPARAM): BOOL; stdcall;

implementation
var
  numFenetre:integer;
  tabClass:array[0..1000]of string;
  tabTexte:array[0..1000] of string;
  tabHandle:array[0..1000] of HWND;

{$R *.DFM}

function EnumWindowsCallback(hWnd: HWND; lParam: LPARAM): BOOL;
Var Texte:array[0..250]of Char;
    Classe:array[0..250]of Char;
begin
  inc(numFenetre);
  GetWindowText(hWnd,Texte,SizeOf(Texte));
  GetClassName(hWnd,Classe,SizeOf(Classe));
  tabHandle[numFenetre]:=hWnd;
  tabTexte[numFenetre]:=string(Texte);
  tabClass[numFenetre]:=string(Classe);
  if numFenetre<1000 then result:=true else result:=false;// pour que l'numration ne s'arrte pas; pour que EnumWindows continue  appeler EnumWindowsCallback pour les autres fentres
end;
  

procedure TForm1.ButtonRegenererClick(Sender: TObject);
{rcupration de toutes les "fentres" en cours d'utilisation}
{on rcupre leur handle, leur classe et leur texte associ}
var i:word;
begin
  ListBox1.Clear;
  numFenetre:=-1;
  EnumWindows(@EnumWindowsCallback,0);// EnumWindows va appeler EnumWindowsCallback pour chaque fenetre prsente
  for i:=0 to numFenetre do
     ListBox1.items.add('classe :'+tabClass[i]+'      Texte: '+tabTexte[i]+'    Handle: '+IntToStr(tabHandle[i]));
end;

procedure TForm1.ButtonWM_CLOSEClick(Sender: TObject);
begin
  //ListBox1.ItemIndex; est le n de la ligne du ListBox slectionne par l'utilisateur
  SendMessage(tabHandle[ListBox1.ItemIndex],WM_CLOSE,0,0);// envoie du message WM_CLOSE
end;




{====================================================================}
{ Autre solution ( dconseiller)                                    }
{====================================================================}

procedure TForm1.ButtonTerminateClick(Sender: TObject);
var
  dwProcessId: DWORD;
  HandleProcess:THandle;
begin
  GetWindowThreadProcessId(tabHandle[ListBox1.ItemIndex],@dwProcessId);//Obtention de l'identifiant du thread (dans la variable dwProcessId) qui a cr la fentre. La fentre est dsigne par son Handle
  if dwProcessId<>0 then
  begin
    HandleProcess:=OpenProcess(PROCESS_TERMINATE,False,dwProcessId); //Obtention du Handle du process  partir de l'identifiant du thread (dwProcessId)
    TerminateProcess(HandleProcess,0);//Arrt du process dsign par HandleProcess. Tous ses threads sont galement arrts.
  end;
end;

end.
